{% extends "layout.html" %}
{% from "form-macro.html" import form_macro %}

{% block title %}
    <a href="/companies">Companies</a>
    <a href="#" >{{ company.name }}</a>
{% endblock%}

{% block bare_body %}
<div class="company company-banner" style="{{ 'background-color: ' + company.background_color + '; color: ' + company.foreground_color + ';'}}">
    <div class="company-header container large" >
        {% if company.logo_file %}
        <img class="logo" src="{{ company.logo_file }}">
        {% endif %}
        {% if not company.logo_file or not company.logo_includes_name %}
        <div class="name">{{ company.name }}</div>
        {% endif %}
    </div>
    
    <div class="company-info container">
        {% for column in [
            [
                ('description', 'What we do'),
                ('technologies', 'Technologies')
            ],
            [
                ('city', 'City'),
                ('address', 'Address'),
                ('size', 'Total employees'),
                ('developers', 'Developers'),
                ('promotext', 'Why work here'),
            ],
            [
                ('intern_welcome', 'Open for interns'),
                ('intern_fee', 'Monthly internship compensation') if company.intern_welcome else ('',''),
                ('english_welcome', 'Internationals welcome') if company.intern_welcome else ('',''),
                ('intern_apply', 'How to apply') if company.intern_welcome else ('','')
            ]
        ] %}
        <div>
            {% for prop, name in column %}
            {% if company[prop] != null and company[prop] is not none and company[prop] != '' %}
            <p>
            <strong>{{name}}:</strong> {{company[prop]}}
            </p>
            {% endif %}
            {% endfor %}
            {% if loop.last %}
            <div>
                <strong>Contacts:</strong>
                <table>
                    {% for contact in company.contacts %}
                    {% if contact.student_visible %}
                    <tr>
                        <td>{{contact.first_name}} {{contact.last_name}}</td>
                        <td>{{contact.role}}</td>
                        <td><a data-tooltip="{{contact.email}}" href="mailto:{{contact.email}}"><svg xmlns="http://www.w3.org/2000/svg" width="1em" height="1em" viewBox="0 0 24 24"><path fill="currentColor" d="M4 20q-.825 0-1.412-.587T2 18V6q0-.825.588-1.412T4 4h16q.825 0 1.413.588T22 6v12q0 .825-.587 1.413T20 20zm8-7l8-5V6l-8 5l-8-5v2z"/></svg></a></td>
                        <td>{% if contact.phone %}<a data-tooltip="{{contact.phone}}" href="tel:{{contact.phone}}"><svg xmlns="http://www.w3.org/2000/svg" width="1em" height="1em" viewBox="0 0 24 24"><path fill="currentColor" d="M6.62 10.79c1.44 2.83 3.76 5.14 6.59 6.59l2.2-2.2c.27-.27.67-.36 1.02-.24c1.12.37 2.33.57 3.57.57c.55 0 1 .45 1 1V20c0 .55-.45 1-1 1c-9.39 0-17-7.61-17-17c0-.55.45-1 1-1h3.5c.55 0 1 .45 1 1c0 1.25.2 2.45.57 3.57c.11.35.03.74-.25 1.02z"/></svg></a>{% endif %}</td>
                    </tr>
                    {% endif %}
                    {% endfor %}
                </table>
            </div>
            {% endif %}
        </div>
        {% endfor %}
    </div>
</div>

<div class="main container">
    {% for message in get_flashed_messages() %}
    <article class="notification is-important">
        {{ message | inline_markdown | safe}}
    </article>
    {% endfor %}

    {% if is_admin %}
    <h1>Company dashboard</h1>
    {% if company.company_publish %}
    <p>The above company profile is what students get to see.</p>
    {% else %}
    <p>Your above company profile is currently <strong>not visible to students</strong>! Click 'Edit company details' below to proceed...</p>
    {% endif %}

    <h2>Actions</h2>
    <ul>
        <li><a href="{{ url_for('edit_company', company_id=company.id)}}">Edit company details</a></li>
        {% if current_user.is_admin %} 
        <li><form style="display: inline;" onsubmit="return confirm('Do you really want to delete this company?');" method="POST" action="{{ url_for('delete_company', company_id=company.id)}}">
            <input type="hidden" name="csrf_token" value="{{ csrf_token() }}">
            <a onclick="this.closest('form').submit();return false;">Delete company</a>
        </form></li>
        {% endif %}
        
        {% if safari %}
            {% set name = 'the upcoming Business Safari on ' + safari.first_date|string %}
            {% if safari.second_date %}
            {% set name = name + ' and ' + safari.second_date|string %}
            {% endif %}
            
            {% if safari.status == 'company_registration' or current_user.is_teacher %}
                {% if safari.get_offer(company.id) %}
                    <li><a href="{{ url_for('show_safari_company', safari_id=safari.id, company_id=company.id) }}">Change availability details for {{name}}</a></li>
                {% else %}
                    <li><a href="{{ url_for('show_safari_company', safari_id=safari.id, company_id=company.id) }}"><strong>Submit availability</strong> for {{name}}</a> &mdash; Note that the deadline is on {{safari.company_signup_end_date}}</li>
                {% endif %}
            {% endif %}
        {% endif %}
    </ul>


    <h2>Update contacts</h2>
    <ul>
        {% for contact in company.contacts %}
        <li>
            {{contact.first_name}} {{contact.last_name}}
            · {{contact.role or 'no role'}}
            · {{'visible' if contact.student_visible else 'hidden'}}
            {{'· safari contact' if contact.safari_messages else ''}}
            · <a href="/companies/{{company.id}}/contacts/{{contact.id}}/edit">Edit</a>
            · <form style="display: inline-block;" method="post" action="/companies/{{company.id}}/contacts/{{contact.id}}/delete"><a onclick="this.closest('form').submit();return false;">Delete</a><input type="hidden" name="csrf_token" value="{{ csrf_token() }}"></form>
        </li>
        {% endfor %}

        {% if not student_contact %}
        <li><strong>Warning: </strong>No student-visible contact person yet</li>
        {% endif %}
        {% if not safari_contact %}
        <li><strong>Warning: </strong>No contact person for Business Safaris yet</li>
        {% endif %}
        <li>
            <a href="/companies/{{company.id}}/contacts/add">Add a contact</a>
        </li>
    </ul>
    {% endif %}

    {% if safari and safari.status != 'company_registration' %}

        {% set offer = safari.get_offer(company.id) %}

        {% if offer and offer.spots %}
            <h1>Business Safari</h1>
            <table>
                <tr><th>Spots available</th><td>{{offer.available_spots}} / {{offer.spots}}</td></tr>
                <tr><th>Date</th><td>
                    {% if offer.use_alt_day %}
                    <p>{{ safari.second_date }} (<strong>alternative!</strong>)</p>
                    {% else %}
                    <p>{{ safari.first_date }}</p>
                    {% endif %}        
                </td></tr>
                <tr><th>Information</th><td>{{ offer.extra_information }}</td></tr>
                <tr><th>Contact person</th><td>{{ offer.contact_person }}</td></tr>
                <tr><th>Contact details</th><td>{{ offer.contact_person_info }}</td></tr>
                <tr><th>Registrations</th><td class="rows1">
                    {% if offer.registrations|length > 0 %}
                        <div class="people-cards">
                            {% for registration in offer.registrations %}
                            <div class="person" style='background-image: linear-gradient(to bottom, rgba(0,0,0,0.4), rgba(0,0,0,0)), url({{ registration.student.avatar }})'>
                                <h3>
                                    {{ registration.student.first_name }}
                                </h3>
                            </div>
                            {% endfor %}
                        </div>
                    {% else %}
                        <p>No participants (yet).</p>
                    {% endif %}

                    {% if not current_user.is_student %}
                    {% elif safari.status != 'student_registration' %}
                        <p>Registration is closed.</p>
                    {% else %}
                        {% set registration = safari.get_registration(current_user.id) %}
                        {% if registration and registration.company_id != company.id %}
                            <p>You are currently registered at a <a href="/companies/{{registration.company_id}}">different company</a>.</p>
                        {% else %}
                            <form method="post">
                                <input type="hidden" name="csrf_token" value="{{ csrf_token() }}">
                                {% if registration %}
                                <input type="submit" name="safari_deregister" value="Deregister">
                                {% elif offer.available_spots %}
                                <input type="submit" name="safari_register" value="Register!">
                                {% else %}
                                <p>No spots available.</p>
                                {% endif %}
                            </form>
                        {% endif %}
                    {% endif %}    
                </td></tr>
            </table>
        {% endif %}
    {% endif %}
</div>

{% if internships %}
<div class="container company-internships">
    <h1>Interns & reviews</h1>
    <ol>
        {% for internship in internships %}
            <li>
                <div>
                    <div>
                        <img class="avatar" src="{{internship.user.avatar}}" alt="Avatar">
                        <h2>{{internship.user.full_name}}</h2>
                    </div>
                    <div>
                        {% if current_user.id == internship.user_id %}
                            <a href="/companies/internship/{{internship.id}}/update">Edit</a>
                        {% endif %}
                        {% if current_user.is_admin %}
                            <form action="/companies/internship/{{internship.id}}/delete" method="POST">
                                <input type="hidden" name="csrf_token" value="{{ csrf_token() }}">
                                <input type="submit" value="Delete">
                            </form>
                        {% endif %}
                    </div>
                </div>
                <div>
                    <table>
                        <tr>
                            <th>Start</th>
                            <th>End</th>
                        </tr>
                        <tr>
                            <td>{{internship.start_date | date}}</td>
                            <td>{{internship.end_date | date}}</td>
                        </tr>
                    </table>
                </div>
                <h4>Review</h4>
                <p>{% if internship.review %}{{internship.review}} {% else %} No review yet... {% endif %}</p>
            </li>
        {% endfor %}
    </ol>
</div>
{% endif %}


{% endblock %}
